program DemoWaitConsole;
{$APPTYPE CONSOLE}
uses
  SysUtils, WindowThread
  , CSplashWindow; //  ;
const CountCalc = 100000000;
var WaitWindow: TThreadWindow;
    i: integer;
    D, MaxD: Double;
    S: string;
{$R SPLASH.res} //   ,     CSplashWindow
begin
  ShowSplash;
  SplashWindow.Percent := -1;
  SplashWindow.Caption := ' ';
  SplashWindow.Text := 'c    ';
  SplashWindow.CaptionFont.Color := $00FF0000;

  Randomize;
  Writeln('DemoWaitConsole');
  Writeln('exp((sin(random*Pi) * sin(random*Pi)) + cos(random*Pi))');
  Writeln('Count: ', CountCalc);
  WaitWindow := TThreadWindow.Show('');
  WaitWindow.AlphaShow := true;
  try
    MaxD := 0;
    for i := 0 to CountCalc - 1 do
    begin
      if (i mod 100000) = 0 then
      begin
        D := i;
        D := D * 1000 / CountCalc;
        WaitWindow.Percent := Round(D);
      end;
      D := exp((sin(random*Pi) * sin(random*Pi)) + cos(random*Pi));
      if D > MaxD then
      begin
        MaxD := D;
        Str(MaxD:10:6, S);
        WaitWindow.Text := 'Wait please' + #13#10 + 'MaxD =' + S;
      end;
      if i = (CountCalc)div(10) then
      begin
        WaitWindow.Enabled := true;
      end;
      if WaitWindow.Canceled then break;
    end;
  finally
    FreeAndNil(WaitWindow);
  end;
end.